# Roo Code 3.15 Release Notes (2025-05-05)

This release introduces prompt caching for Google Vertex, improved terminal command handling, UI/UX enhancements, provider updates, performance improvements, and several other improvements and bug fixes across versions 3.15.0 to 3.15.5.

## Prompt Caching for Google Vertex

*   Added prompt caching capabilities to the Google Vertex provider for potentially faster and more cost-effective responses (thanks ashktn).

## Improved Terminal Command Handling

*   Implemented a [fallback mechanism](/features/shell-integration#command-execution-fallback) for executing terminal commands if VSCode terminal shell integration fails.
*   Added the ability to stop commands directly from the chat UI.

    <img src="/img/v3.15.0/v3.15.0-2.png" width="600" />

## Boomerang Orchestrator Mode

*   Enhanced Orchestrator (Boomerang) mode strictly orchestrates tasks.
*   No longer reads, writes, executes commands, or utilizes MCP servers; offloads these tasks to other modes.
*   Provides more predictable and secure task automation.

## Settings Import/Export

*   Roo Code settings can now be imported directly from the welcome screen (thanks julionav).
*   Fixed importing & exporting of custom modes (thanks julionav).

## QOL Improvements

*   Play notification sound (when enabled) only when action is needed from the user (thanks olearycrew!).
*   Improved the UI/UX of code snippets in the chat (thanks KJ7LNW).
*   Adjusted chat view padding to accommodate small width layouts (thanks zhangtony239).
*   Fixed chat input height instability during window resizing (thanks zhangtony239!).
*   Corrected chat layout padding issues during window resizing (thanks zhangtony239!).
*   Simplified and streamlined Roo Code's [quick actions](/features/code-actions).

    <img src="/img/v3.15/v3.15-1.png" width="350" />

*   Improved the auto-approve toggle buttons for some high-contrast VSCode themes.
*   Offloaded expensive count token operations to a web worker for better performance (thanks samhvw8).
*   Improved support for multi-root workspaces (thanks snoyiatk).
*   Improved the performance of mode switching (thanks dlab-anton).
*   Improved Mermaid diagram rendering with clearer error messages and a copy code button.

    <img src="/img/v3.15.2/v3.15.2.png" alt="Mermaid diagram error message with copy code button" width="600" />

*   Made the integrated terminal significantly faster and smoother.
*   Improved the reliability of stopping terminal commands.
*   Refined inline code styling in chat for better readability (thanks dicharkan!).
*   Clarified tool group display in the Modes view when no tool groups are present.
*   Rendering performance improvements for code blocks in chat (thanks KJ7LNW!).

## Bug Fixes

*   Fix a nasty bug that would cause Roo Code to hang, particularly in orchestrator mode.
*   Terminal: Fix empty command bug.
*   Terminal: More robust process killing.
*   Made retries respect the global auto-approve checkbox.
*   Fixed a selection mode bug in the history view (thanks jr!).
*   Fixed file mentions for filenames containing spaces.
*   Fixed importing & exporting of custom modes (thanks julionav).

## Provider Updates

*   Added prompt caching for Google Vertex (thanks ashktn).
*   Added a reasoning effort setting for OpenAI Compatible providers (thanks mr-ryan-james).
*   Added support for custom API base URLs for OpenAI/OpenAI Compatible providers (thanks gongzhongqiang!).
*   Added support for custom headers for OpenAI Compatible providers.
*   Update `@google/genai` to `0.12` (includes some streaming completion bug fixes).
*   Improve Gemini caching efficiency.
*   Optimize Gemini prompt caching for OpenRouter.

## Misc Improvements

*   Chat view performance improvements.
*   Removed unused types (thanks wkordalski).